<?php
/**
 * Catch Everest Customizer/Theme Options
 *
 * @package Catch Themes
 * @subpackage Catch Everest
 * @since Catch Everest 2.5
 */

/**
 * Implements Catch Everest theme options into Theme Customizer.
 *
 * @param $wp_customize Theme Customizer object
 * @return void
 *
 * @since Catch Everest 2.5
 */
function catcheverest_customize_register( $wp_customize ) {
	global $catcheverest_options_settings, $catcheverest_options_defaults;

    $options = $catcheverest_options_settings;

	$defaults = $catcheverest_options_defaults;

	//Custom Controls
	require get_template_directory() . '/inc/panel/customizer/customizer-custom-controls.php';

	$theme_slug = 'catcheverest_';

	$settings_page_tabs = array(
		'theme_options' => array(
			'id' 			=> 'theme_options',
			'title' 		=> __( 'Theme Options', 'catch-everest' ),
			'description' 	=> __( 'Basic theme Options', 'catch-everest' ),
			'sections' 		=> array(
				'responsive_design' => array(
					'id' 			=> 'responsive_design',
					'title' 		=> __( 'Responsive Design', 'catch-everest' ),
					'description' 	=> '',
				),
				'favicon' => array(
					'id' 			=> 'favicon',
					'title' 		=> __( 'Favicon', 'catch-everest' ),
					'description' 	=> '',
				),
				'web_clip_icon_options' => array(
					'id' 			=> 'web_clip_icon_options',
					'title' 		=> __( 'Webclip Icon Options', 'catch-everest' ),
					'description' 	=> __( 'Web Clip Icon for Apple devices. Recommended Size - Width 144px and Height 144px height, which will support High Resolution Devices like iPad Retina', 'catch-everest' )
				),
				'header_right_section' => array(
					'id' 			=> 'header_right_section',
					'title' 		=> __( 'Header Right Section', 'catch-everest' ),
					'description' 	=> '',
				),
				'content_options' => array(
					'id' 			=> 'content_options',
					'title' 		=> __( 'Content Featured Image Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'layout_options' => array(
					'id' 			=> 'layout_options',
					'title' 		=> __( 'Layout Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'typography' => array(
					'id' 			=> 'typography',
					'title' 		=> __( 'Font Family Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'search_text_settings' => array(
					'id' 			=> 'search_text_settings',
					'title' 		=> __( 'Search Text Settings', 'catch-everest' ),
					'description' 	=> '',
				),
				'excerpt_more_tag_settings' => array(
					'id' 			=> 'excerpt_more_tag_settings',
					'title' 		=> __( 'Excerpt / More Tag Settings', 'catch-everest' ),
					'description' 	=> '',
				),
				'feed_redirect' => array(
					'id' 			=> 'feed_redirect',
					'title' 		=> __( 'Feed Redirect', 'catch-everest' ),
					'description' 	=> '',
				),
				'layout_options' => array(
					'id' 			=> 'layout_options',
					'title' 		=> __( 'Layout Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'header_options' => array(
					'id' 			=> 'header_options',
					'title' 		=> __( 'Header Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'content_featured_image_options' => array(
					'id' 			=> 'content_featured_image_options',
					'title' 		=> __( 'Content Featured Image Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'promotion_headline_options' => array(
					'id' 			=> 'promotion_headline_options',
					'title' 		=> __( 'Promotion Headline Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'homepage_settings' => array(
					'id' 			=> 'homepage_settings',
					'title' 		=> __( 'Homepage/Frontpage Settings', 'catch-everest' ),
					'description' 	=> '',
				),
				'comment_options' => array(
					'id' 			=> 'comment_options',
					'title' 		=> __( 'Comment Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'footer_options' => array(
					'id' 			=> 'footer_options',
					'title' 		=> __( 'Footer Editor Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'custom_css' => array(
					'id' 			=> 'custom_css',
					'title' 		=> __( 'Custom CSS', 'catch-everest' ),
					'description' 	=> '',
				),
				'scrollup_options' => array(
					'id' 			=> 'scrollup_options',
					'title' 		=> __( 'Scroll Up', 'catch-everest' ),
					'description' 	=> '',
				),
				'update_notifier' => array(
					'id' 			=> 'update_notifier',
					'title' 		=> __( 'Update Notifier', 'catch-everest' ),
					'description' 	=> '',
				),

			),
		),
		'homepage_settings' => array(
			'id' 			=> 'homepage_settings',
			'title' 		=> __( 'Homepage Settings', 'catch-everest' ),
			'description' 	=> __( 'Homepage Settings', 'catch-everest' ),
			'sections' 		=> array(
				'homepage_headline_options' => array(
					'id' 			=> 'homepage_headline_options',
					'title' 		=> __( 'Homepage Headline Options', 'catch-everest' ),
					'description' 	=> '',
				),
				'homepage_featured_content_options' => array(
					'id' 			=> 'homepage_featured_content_options',
					'title' 		=> __( 'Homepage Featured Content options', 'catch-everest' ),
					'description' 	=> '',
				),
				'homepage_frontpage_settings' => array(
					'id' 			=> 'homepage_frontpage_settings',
					'title' 		=> __( 'Homepage / Frontpage Settings', 'catch-everest' ),
					'description' 	=> '',
				),
			)
		),

		'featured_slider' => array(
			'id' 			=> 'featured_slider',
			'title' 		=> __( 'Featured Slider', 'catch-everest' ),
			'description' 	=> __( 'Featured Slider', 'catch-everest' ),
			'sections' 		=> array(
				'slider_options' => array(
					'id' 			=> 'slider_options',
					'title' 		=> __( 'Slider Options', 'catch-everest' ),
					'description' 	=> '',
				),
			)
		),

		'social_links' => array(
			'id' 			=> 'social_links',
			'title' 		=> __( 'Social Links', 'catch-everest' ),
			'description' 	=> __( 'Add your social links here', 'catch-everest' ),
			'sections' 		=> array(
				'predefined_social_icons' => array(
					'id' 			=> 'predefined_social_icons',
					'title' 		=> __( 'Predefined Social Icons', 'catch-everest' ),
					'description' 	=> '',
				),
				'custom_social_icons' => array(
					'id' 			=> 'custom_social_links',
					'title' 		=> __( 'Custom Social Links', 'catch-everest' ),
					'description' 	=> '',
				),
			),
		),
		'webmaster_tool' => array(
			'id' 			=> 'webmaster_tool',
			'title' 		=> __( 'Webmaster Tools', 'catch-everest' ),
			'description' 	=> '',
			'sections' 		=> array(
				'predefined_social_icons' => array(
					'id' 			=> 'site_verification',
					'title' 		=> __( 'Site Verification', 'catch-everest' ),
					'description' 	=> '',
				),
				'custom_social_icons' => array(
					'id' 			=> 'header_footer_codes',
					'title' 		=> __( 'Header Footer Codes', 'catch-everest' ),
					'description' 	=> '',
				),
			),
		),
	);

	$wp_customize->get_control('header_textcolor')->priority = '90';
	$wp_customize->get_control('header_textcolor')->label 	 = __( 'Custom Header Color', 'catch-everest' );
	$wp_customize->get_control('background_color')->priority = '20';
	$wp_customize->get_control('background_color')->label 	 = __( 'Custom Background Color', 'catch-everest' );

	if ( !function_exists( 'has_custom_logo' ) ) {
		//@remove if block when WordPress version 4.8 is released
		$wp_customize->get_control('header_image')->section 	= 'title_tagline';
		$wp_customize->get_control('header_image')->priority 	= '80';
	}

	//Add Panels and sections
	foreach ( $settings_page_tabs as $panel ) {
		$wp_customize->add_panel(
			$theme_slug . $panel['id'],
			array(
				'priority' 		=> 200,
				'capability' 	=> 'edit_theme_options',
				'title' 		=> $panel['title'],
				'description' 	=> $panel['description'],
			)
		);

		// Loop through tabs for sections
		foreach ( $panel['sections'] as $section ) {
			$params = array(
								'title'			=> $section['title'],
								'description'	=> $section['description'],
								'panel'			=> $theme_slug . $panel['id']
							);

			if ( isset( $section['active_callback'] ) ) {
				$params['active_callback'] = $section['active_callback'];
			}

			$wp_customize->add_section(
				// $id
				$theme_slug . $section['id'],
				// parameters
				$params

			);
		}
	}

	$settings_parameters = array(
		'disable_responsive' => array(
			'id' 			=> 'disable_responsive',
			'title' 		=> __( 'Check to Disable Responsive Design', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'section' 		=> 'responsive_design',
			'default' 		=> $defaults['disable_responsive'],
		),
		'enable_responsive_zoom' => array(
			'id' 			=> 'enable_responsive_zoom',
			'title' 		=> __( 'Check to Enable Zoom in Mobile Devices', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'section' 		=> 'responsive_design',
			'default' 		=> $defaults['enable_responsive_zoom'],
		),
		'enable_menus' => array(
			'id' 			=> 'enable_menus',
			'title' 		=> __( 'Check to Enable Footer Menu in Mobile Devices', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'section' 		=> 'responsive_design',
			'default' 		=> $defaults['enable_menus'],
		),

		//Site Identity
		'site_title_above' => array(
			'id' 				=> 'site_title_above',
			'title' 			=> __( 'Check to Check to move Site Title & Description above the Header/Logo Image', 'catch-everest' ),
			'description'		=> '',
			'field_type' 		=> 'checkbox',
			'sanitize' 			=> 'catcheverest_sanitize_checkbox',
			'section' 			=> 'title_tagline',
			'default' 			=> $defaults['site_title_above'],
			'priority'			=> '90',
		),

		//Header Right Sidebar
		'disable_header_right_sidebar' => array(
			'id' 			=> 'disable_header_right_sidebar',
			'title' 		=> __( 'Check to Disable Header Right Section', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'theme_options',
			'section' 		=> 'header_right_section',
			'default' 		=> $defaults['disable_header_right_sidebar']
		),

		//Header Featured Image
		'enable_featured_header_image' => array(
			'id' 			=> 'enable_featured_header_image',
			'title' 		=> __( 'Enable Featured Header Image', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'section' 		=> 'header_image',
			'default' 		=> $defaults['enable_featured_header_image'],
			'choices'		=> catcheverest_enable_header_featured_image(),
		),
		'page_featured_image' => array(
			'id' 				=> 'page_featured_image',
			'title' 			=> __( 'Page/Post Featured Image Size', 'catch-everest' ),
			'description'		=> '',
			'field_type' 		=> 'select',
			'sanitize' 			=> 'catcheverest_sanitize_select',
			'section' 			=> 'header_image',
			'default' 			=> $defaults['page_featured_image'],
			'choices'			=> catcheverest_page_post_featured_image_size(),
			'active_callback' 	=> 'catcheverest_is_header_featured_image_enabled',
		),
		'featured_header_image_position' => array(
			'id' 			=> 'featured_header_image_position',
			'title' 		=> __( 'Featured Header Image Position', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'section' 		=> 'header_image',
			'default' 		=> $defaults['featured_header_image_position'],
			'choices'		=> catcheverest_featured_header_image_position(),
			'active_callback' 	=> 'catcheverest_is_header_featured_image_enabled',
		),
		'featured_header_image_alt' => array(
			'id' 			=> 'featured_header_image_alt',
			'title' 		=> __( 'Featured Header Image Alt/Title Tag', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'text',
			'sanitize' 		=> 'sanitize_text_field',
			'section' 		=> 'header_image',
			'default' 		=> $defaults['featured_header_image_alt'],
			'active_callback' 	=> 'catcheverest_is_header_featured_image_enabled',
		),
		'featured_header_image_url' => array(
			'id' 			=> 'featured_header_image_url',
			'title' 		=> __( 'Featured Header Image Link URL', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'section' 		=> 'header_image',
			'default' 		=> $defaults['featured_header_image_url'],
			'active_callback' 	=> 'catcheverest_is_header_featured_image_enabled',
		),
		'featured_header_image_base' => array(
			'id' 			=> 'featured_header_image_base',
			'title' 		=> __( 'Check to Open Link in New Window', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'section' 		=> 'header_image',
			'default' 		=> $defaults['featured_header_image_base'],
			'active_callback' 	=> 'catcheverest_is_header_featured_image_enabled',
		),

		//Content Featured Image
		'featured_image' => array(
			'id' 			=> 'featured_image',
			'title' 		=> __( 'Check to Disable Header Right Section', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'content_featured_image_options',
			'default' 		=> $defaults['featured_image'],
			'choices'		=> catcheverest_content_featured_image_size(),
		),

		//Layout Options
		'sidebar_layout' => array(
			'id' 			=> 'sidebar_layout',
			'title' 		=> __( 'Sidebar Layout Options', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'layout_options',
			'default' 		=> $defaults['sidebar_layout'],
			'choices'		=> catcheverest_sidebar_layout_options(),
		),
		'content_layout' => array(
			'id' 			=> 'content_layout',
			'title' 		=> __( 'Content Layout', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'layout_options',
			'default' 		=> $defaults['content_layout'],
			'choices'		=> catcheverest_content_layout_options(),
		),
		'reset_layout' => array(
			'id' 			=> 'reset_layout',
			'title' 		=> __( 'Check to Reset Layout', 'catch-everest' ),
			'description'	=> __( 'Please refresh the customizer after saving if reset option is used', 'catch-everest' ),
			'transport'		=> 'postMessage',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_reset_layout',
			'panel' 		=> 'theme_options',
			'section' 		=> 'layout_options',
			'default' 		=> $defaults['reset_layout']
		),

		//Color Options
		'color_scheme' => array(
			'id' 			=> 'color_scheme',
			'title' 		=> __( 'Default Color Scheme', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'radio',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'section' 		=> 'colors',
			'default' 		=> $defaults['color_scheme'],
			'choices'		=> catcheverest_color_schemes(),
			'priority'		=> '10',
		),
		'header_background' => array(
			'id' 			=> 'header_background',
			'title' 		=> __( 'Header Background', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['header_background'],
			'priority'		=> '50',
		),
		'content_background' => array(
			'id' 			=> 'content_background',
			'title' 		=> __( 'Content Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['content_background'],
			'priority'		=> '60',
		),
		'footer_sidebar_background' => array(
			'id' 			=> 'footer_sidebar_background',
			'title' 		=> __( 'Footer Sidebar Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['footer_sidebar_background'],
			'priority'		=> '70',
		),
		'footer_background' => array(
			'id' 			=> 'footer_background',
			'title' 		=> __( 'Footer Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['footer_background'],
			'priority'		=> '80',
		),
		'title_color' => array(
			'id' 			=> 'title_color',
			'title' 		=> __( 'Title Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['title_color'],
			'priority'		=> '100',
		),
		'title_hover_color' => array(
			'id' 			=> 'title_hover_color',
			'title' 		=> __( 'Title Hover Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['title_hover_color'],
			'priority'		=> '110',
		),
		'meta_color' => array(
			'id' 			=> 'meta_color',
			'title' 		=> __( 'Meta Description Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['meta_color'],
			'priority'		=> '120',
		),
		'text_color' => array(
			'id' 			=> 'text_color',
			'title' 		=> __( 'Text Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['text_color'],
			'priority'		=> '130',
		),
		'link_color' => array(
			'id' 			=> 'link_color',
			'title' 		=> __( 'Link Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['link_color'],
			'priority'		=> '140',
		),
		'widget_title_color' => array(
			'id' 			=> 'widget_title_color',
			'title' 		=> __( 'Sidebar Widget Title Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['widget_title_color'],
			'priority'		=> '150',
		),
		'widget_color' => array(
			'id' 			=> 'widget_color',
			'title' 		=> __( 'Sidebar Widget Text Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['widget_color'],
			'priority'		=> '160',
		),
		'widget_link_color' => array(
			'id' 			=> 'widget_link_color',
			'title' 		=> __( 'Sidebar Widget Link Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['widget_link_color'],
			'priority'		=> '170',
		),
		'home_headline_background' => array(
			'id' 			=> 'home_headline_background',
			'title' 		=> __( 'Homepage Headline Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['home_headline_background'],
			'priority'		=> '180',
		),
		'home_headline' => array(
			'id' 			=> 'home_headline',
			'title' 		=> __( 'Homepage Headline Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['home_headline'],
			'priority'		=> '190',
		),
		'menu_background' => array(
			'id' 			=> 'menu_background',
			'title' 		=> __( 'Menu Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['menu_background'],
			'priority'		=> '200',
		),
		'menu_color' => array(
			'id' 			=> 'menu_color',
			'title' 		=> __( 'Menu Text Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['menu_color'],
			'priority'		=> '210',
		),
		'hover_active_color' => array(
			'id' 			=> 'hover_active_color',
			'title' 		=> __( 'Menu Hover & Active Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['hover_active_color'],
			'priority'		=> '220',
		),
		'hover_active_text_color' => array(
			'id' 			=> 'hover_active_text_color',
			'title' 		=> __( 'Menu Hover & Active Text Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['hover_active_text_color'],
			'priority'		=> '230',
		),
		'sub_menu_bg_color' => array(
			'id' 			=> 'sub_menu_bg_color',
			'title' 		=> __( 'Sub-Menu Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['sub_menu_bg_color'],
			'priority'		=> '240',
		),
		'sub_menu_text_color' => array(
			'id' 			=> 'sub_menu_text_color',
			'title' 		=> __( 'Sub-Menu Text Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['sub_menu_text_color'],
			'priority'		=> '250',
		),
		'scrollup_bg_color' => array(
			'id' 			=> 'scrollup_bg_color',
			'title' 		=> __( 'Scroll Up Background Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['scrollup_bg_color'],
			'priority'		=> '280',
		),
		'scrollup_text_color' => array(
			'id' 			=> 'scrollup_text_color',
			'title' 		=> __( 'Scroll Up Text Color', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'color',
			'sanitize' 		=> 'sanitize_hex_color',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['scrollup_text_color'],
			'priority'		=> '290',
		),

		'reset_color' => array(
			'id' 			=> 'reset_color',
			'title' 		=> __( 'Check to Reset Colors', 'catch-everest' ),
			'description'	=> __( 'Please refresh the customizer after saving if reset option is used', 'catch-everest' ),
			'transport'		=> 'postMessage',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_reset_colors',
			'panel' 		=> 'theme_options',
			'section' 		=> 'colors',
			'default' 		=> $defaults['reset_color'],
			'priority'		=> '300',
		),

		//Typography
		'body_font' => array(
			'id' 			=> 'body_font',
			'title' 		=> __( 'Default Font Family', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['body_font'],
			'choices'		=> catcheverest_available_fonts()
		),
		'title_font' => array(
			'id' 			=> 'title_font',
			'title' 		=> __( 'Site Title Font Family', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['title_font'],
			'choices'		=> catcheverest_available_fonts()
		),
		'tagline_font' => array(
			'id' 			=> 'tagline_font',
			'title' 		=> __( 'Site Tagline Font Family', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['tagline_font'],
			'choices'		=> catcheverest_available_fonts()
		),
		'content_tittle_font' => array(
			'id' 			=> 'content_tittle_font',
			'title' 		=> __( 'Content Title Font Family', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['content_tittle_font'],
			'choices'		=> catcheverest_available_fonts()
		),
		'content_font' => array(
			'id' 			=> 'content_font',
			'title' 		=> __( 'Content Body Font Family', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['content_font'],
			'choices'		=> catcheverest_available_fonts()
		),
		'headings_font' => array(
			'id' 			=> 'headings_font',
			'title' 		=> __( 'Headings Tags from h1 to h6 Font Family', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['headings_font'],
			'choices'		=> catcheverest_available_fonts()
		),
		'reset_typography' => array(
			'id' 			=> 'reset_typography',
			'title' 		=> __( 'Check to Reset Fonts', 'catch-everest' ),
			'description'	=> __( 'Please refresh the customizer after saving if reset option is used', 'catch-everest' ),
			'transport'		=> 'postMessage',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_reset_typography',
			'panel' 		=> 'theme_options',
			'section' 		=> 'typography',
			'default' 		=> $defaults['reset_typography'],
		),

		//Search Settings
		'search_display_text' => array(
			'id' 			=> 'search_display_text',
			'title' 		=> __( 'Default Display Text in Search', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'text',
			'sanitize' 		=> 'sanitize_text_field',
			'panel' 		=> 'theme_options',
			'section' 		=> 'search_text_settings',
			'default' 		=> $defaults['search_display_text']
		),

		//Excerpt More Settings
		'more_tag_text' => array(
			'id' 			=> 'more_tag_text',
			'title' 		=> __( 'More Tag Text', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'text',
			'sanitize' 		=> 'sanitize_text_field',
			'panel' 		=> 'theme_options',
			'section' 		=> 'excerpt_more_tag_settings',
			'default' 		=> $defaults['more_tag_text']
		),
		'excerpt_length' => array(
			'id' 			=> 'excerpt_length',
			'title' 		=> __( 'Excerpt length(words)', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'number',
			'sanitize' 		=> 'catcheverest_sanitize_number_range',
			'panel' 		=> 'theme_options',
			'section' 		=> 'excerpt_more_tag_settings',
			'default' 		=> $defaults['excerpt_length'],
			'input_attrs' 	=> array(
					            'style' => 'width: 45px;',
					            'min'   => 0,
					            'max'   => 999999,
					            'step'  => 1,
					        	)
		),
		'reset_moretag' => array(
			'id' 			=> 'reset_moretag',
			'title' 		=> __( 'Check to Reset Excerpt', 'catch-everest' ),
			'description'	=> __( 'Please refresh the customizer after saving if reset option is used', 'catch-everest' ),
			'transport'		=> 'postMessage',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_reset_moretag',
			'panel' 		=> 'theme_options',
			'section' 		=> 'excerpt_more_tag_settings',
			'default' 		=> $defaults['reset_moretag']
		),

		//Feed Url
		'feed_url' => array(
			'id' 				=> 'feed_url',
			'title' 			=> __( 'Feed Redirect URL', 'catch-everest' ),
			'description' 		=> __( ' Add in the Feedburner URL', 'catch-everest' ),
			'field_type' 		=> 'url',
			'sanitize' 			=> 'esc_url_raw',
			'panel' 			=> 'theme_options',
			'section' 			=> 'feed_redirect',
			'default' 			=> $defaults['feed_url'],
		),

		//Comment Options
		'commenting_setting' => array(
			'id' 			=> 'commenting_setting',
			'title' 		=> __( 'Disable Comment', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'theme_options',
			'section' 		=> 'comment_options',
			'default' 		=> $defaults['commenting_setting'],
			'choices'		=> catcheverest_comment_option(),
		),

		//Footer Editor Option
		'footer_code' => array(
			'id' 				=> 'footer_code',
			'title' 			=> __( 'Footer Editor', 'catch-everest' ),
			'description'		=> __( 'You can add custom HTML and/or shortcodes, which will be automatically inserted into your theme.
Some shorcodes: [footer-image], [the-year], [site-link], [wp-link] for current year, your site link, wordpress site link respectively.', 'catch-everest' ),
			'field_type' 		=> 'textarea',
			'sanitize' 			=> 'catcheverest_sanitize_footer_code',
			'panel' 			=> 'theme_options',
			'section' 			=> 'footer_options',
			'default' 			=> $defaults['footer_code'],
		),
		'reset_footer' => array(
			'id' 				=> 'reset_footer',
			'title' 			=> __( 'Check to Reset Footer', 'catch-everest' ),
			'description'		=> __( 'Please refresh the customizer after saving if reset option is used', 'catch-everest' ),
			'transport'			=> 'postMessage',
			'field_type' 		=> 'checkbox',
			'sanitize' 			=> 'catcheverest_sanitize_reset_footer',
			'panel' 			=> 'theme_options',
			'section' 			=> 'footer_options',
			'default' 			=> $defaults['reset_footer'],
		),

		//Custom Css
		'custom_css' => array(
			'id' 			=> 'custom_css',
			'title' 		=> __( 'Enter your custom CSS styles', 'catch-everest' ),
			'description' 	=> '',
			'field_type' 	=> 'textarea',
			'sanitize' 		=> 'catcheverest_sanitize_custom_css',
			'panel' 		=> 'theme_options',
			'section' 		=> 'custom_css',
			'default' 		=> $defaults['custom_css']
		),

		//Update Notifier
		'disable_scrollup' => array(
			'id' 			=> 'disable_scrollup',
			'title' 		=> __( 'Check to Disable Scroll Up', 'catch-everest' ),
			'description' 	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'theme_options',
			'section' 		=> 'scrollup_options',
			'default' 		=> $defaults['disable_scrollup']
		),

		//Update Notifier
		'disable_notifier' => array(
			'id' 			=> 'disable_notifier',
			'title' 		=> __( 'Check to Disable Update Notifier', 'catch-everest' ),
			'description' 	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'theme_options',
			'section' 		=> 'update_notifier',
			'default' 		=> $defaults['disable_notifier']
		),

		//Homepage Headline Options
		'homepage_headline' => array(
			'id' 			=> 'homepage_headline',
			'title' 		=> __( 'Homepage Headline Text', 'catch-everest' ),
			'description' 	=> __( 'Appropriate Words: 10', 'catch-everest' ),
			'field_type' 	=> 'textarea',
			'sanitize' 		=> 'wp_kses_post',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_headline_options',
			'default' 		=> $defaults['homepage_headline']
		),
		'homepage_subheadline' => array(
			'id' 			=> 'homepage_subheadline',
			'title' 		=> __( 'Homepage Subheadline Text', 'catch-everest' ),
			'description' 	=> __( 'Appropriate Words: 15', 'catch-everest' ),
			'field_type' 	=> 'textarea',
			'sanitize' 		=> 'wp_kses_post',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_headline_options',
			'default' 		=> $defaults['homepage_subheadline']
		),
		'disable_homepage_headline' => array(
			'id' 			=> 'disable_homepage_headline',
			'title' 		=> __( 'Check to Disable Homepage Headline', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_headline_options',
			'default' 		=> $defaults['disable_homepage_headline']
		),
		'disable_homepage_subheadline' => array(
			'id' 			=> 'disable_homepage_subheadline',
			'title' 		=> __( 'Check to Disable Homepage Subheadline', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_headline_options',
			'default' 		=> $defaults['disable_homepage_subheadline']
		),

		//Homepage/Frontpage Settings
		'enable_posts_home' => array(
			'id' 			=> 'enable_posts_home',
			'title' 		=> __( 'Check to Enable Latest Posts', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_frontpage_settings',
			'default' 		=> $defaults['enable_posts_home']
		),
		'front_page_category' => array(
			'id' 			=> 'front_page_category',
			'title' 		=> __( 'Homepage posts categories:', 'catch-everest' ),
			'description'	=> __( 'Only posts that belong to the categories selected here will be displayed on the front page', 'catch-everest' ),
			'field_type' 	=> 'category-multiple',
			'sanitize' 		=> 'catcheverest_sanitize_category_list',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_frontpage_settings',
			'default' 		=> $defaults['front_page_category']
		),

		//Featured Content
		'disable_homepage_featured' => array(
			'id' 			=> 'disable_homepage_featured',
			'title' 		=> __( 'Check to Disable Homepage Featured Content', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'checkbox',
			'sanitize' 		=> 'catcheverest_sanitize_checkbox',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_featured_content_options',
			'default' 		=> $defaults['disable_homepage_featured'],
		),
		'homepage_featured_headline' => array(
			'id' 			=> 'homepage_featured_headline',
			'title' 		=> __( 'Featured Content Headline Text', 'catch-everest' ),
			'description'	=> __( 'Leave empty if you want to remove headline', 'catch-everest' ),
			'field_type' 	=> 'text',
			'sanitize' 		=> 'sanitize_text_field',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_featured_content_options',
			'default' 		=> $defaults['homepage_featured_headline']
		),
		'homepage_featured_qty' => array(
			'id' 			=> 'homepage_featured_qty',
			'title' 		=> __( 'Number of Featured Content', 'catch-everest' ),
			'description'		=> __( 'Customizer page needs to be refreshed after saving if number of featured content is changed', 'catch-everest' ),
			'field_type' 	=> 'number',
			'sanitize' 		=> 'catcheverest_sanitize_number_range',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_featured_content_options',
			'default' 		=> $defaults['homepage_featured_qty'],
			'input_attrs' 	=> array(
					            'style' => 'width: 45px;',
					            'min'   => 0,
					            'max'   => 24,
					            'step'  => 1,
					        	)
		),
		'homepage_featured_layout' => array(
			'id' 			=> 'homepage_featured_layout',
			'title' 		=> __( 'Featured Content Headline Text', 'catch-everest' ),
			'description'	=> __( 'Leave empty if you want to remove headline', 'catch-everest' ),
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'homepage_settings',
			'section' 		=> 'homepage_featured_content_options',
			'default' 		=> $defaults['homepage_featured_layout'],
			'choices'		=> catcheverest_homepage_featured_layout(),
		),

		//Slider Options
		'enable_slider' => array(
			'id' 			=> 'enable_slider',
			'title' 		=> __( 'Enable Slider', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'select',
			'sanitize' 		=> 'catcheverest_sanitize_select',
			'panel' 		=> 'featured_slider',
			'section' 		=> 'slider_options',
			'default' 		=> $defaults['enable_slider'],
			'choices'		=> catcheverest_enable_slider_options(),
		),
		'slider_qty' => array(
			'id' 				=> 'slider_qty',
			'title' 			=> __( 'Number of Slides', 'catch-everest' ),
			'description'		=> __( 'Customizer page needs to be refreshed after saving if number of slides is changed', 'catch-everest' ),
			'field_type' 		=> 'number',
			'sanitize' 			=> 'catcheverest_sanitize_number_range',
			'panel' 			=> 'featured_slider',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['slider_qty'],
			'input_attrs' 		=> array(
						            'style' => 'width: 45px;',
						            'min'   => 0,
						            'max'   => 20,
						            'step'  => 1,
						        	),
			'active_callback'	=> 'catcheverest_is_slider_active',
		),
		'transition_effect' => array(
			'id' 				=> 'transition_effect',
			'title' 			=> __( 'Transition Effect', 'catch-everest' ),
			'description'		=> '',
			'field_type' 		=> 'select',
			'sanitize' 			=> 'catcheverest_sanitize_select',
			'panel' 			=> 'featured_slider',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['transition_effect'],
			'choices'			=> catcheverest_transition_effects(),
			'active_callback'	=> 'catcheverest_is_slider_active',
		),
		'transition_delay' => array(
			'id' 				=> 'transition_delay',
			'title' 			=> __( 'Transition Delay', 'catch-everest' ),
			'description'		=> '',
			'field_type' 		=> 'number',
			'sanitize' 			=> 'catcheverest_sanitize_number_range',
			'panel' 			=> 'featured_slider',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['transition_delay'],
			'input_attrs' 		=> array(
						            'style' => 'width: 45px;',
						            'min'   => 0,
						            'max'   => 999999999,
						            'step'  => 1,
						        	),
			'active_callback'	=> 'catcheverest_is_slider_active',
		),
		'transition_duration' => array(
			'id' 				=> 'transition_duration',
			'title' 			=> __( 'Transition Length', 'catch-everest' ),
			'description'		=> '',
			'field_type' 		=> 'number',
			'sanitize' 			=> 'catcheverest_sanitize_number_range',
			'panel' 			=> 'featured_slider',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['transition_duration'],
			'input_attrs' 		=> array(
						            'style' => 'width: 45px;',
						            'min'   => 0,
						            'max'   => 999999999,
						            'step'  => 1,
						        	),
			'active_callback'	=> 'catcheverest_is_slider_active',
		),
		'select_slider_type' => array(
			'id' 				=> 'select_slider_type',
			'title' 			=> __( 'Select Slider Type', 'catch-everest' ),
			'description'		=> '',
			'field_type' 		=> 'select',
			'sanitize' 			=> 'catcheverest_sanitize_select',
			'panel' 			=> 'featured_slider',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['select_slider_type'],
			'choices'			=> catcheverest_slider_types(),
			'active_callback'	=> 'catcheverest_is_slider_active',
		),

		//Featured Post Slider
		'exclude_slider_post' => array(
			'id' 				=> 'exclude_slider_post',
			'title' 			=> __( 'Check to Exclude Slider posts from Homepage posts', 'catch-everest' ),
			'description'		=> __( 'Please refresh the customizer after saving if reset option is used', 'catch-everest' ),
			'field_type' 		=> 'checkbox',
			'sanitize' 			=> 'catcheverest_sanitize_checkbox',
			'panel' 			=> 'featured_slider',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['exclude_slider_post'],
			'active_callback'	=> 'catcheverest_is_post_slider_active'
		),
		//Featured Category Slider
		'slider_category' => array(
			'id' 				=> 'slider_category',
			'title' 			=> __( 'Select Slider Categories', 'catch-everest' ),
			'description'		=> __( 'Only posts that belong to the categories selected here will be displayed on the front page', 'catch-everest' ),
			'field_type' 		=> 'category-multiple',
			'sanitize' 			=> 'catcheverest_sanitize_category_list',
			'section' 			=> 'slider_options',
			'default' 			=> $defaults['slider_category'],
			'active_callback'	=> 'catcheverest_is_category_slider_active'
		),

		//Social Links
		'social_facebook' => array(
			'id' 			=> 'social_facebook',
			'title' 		=> __( 'Facebook', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_facebook'],
		),
		'social_twitter' => array(
			'id' 			=> 'social_twitter',
			'title' 		=> __( 'Twitter', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_twitter']
		),
		'social_googleplus' => array(
			'id' 			=> 'social_googleplus',
			'title' 		=> __( 'Google+', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_googleplus']
		),
		'social_pinterest' => array(
			'id' 			=> 'social_pinterest',
			'title' 		=> __( 'Pinterest', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_pinterest']
		),
		'social_youtube' => array(
			'id' 			=> 'social_youtube',
			'title' 		=> __( 'Youtube', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_youtube']
		),
		'social_vimeo' => array(
			'id' 			=> 'social_vimeo',
			'title' 		=> __( 'Vimeo', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_vimeo']
		),
		'social_linkedin' => array(
			'id' 			=> 'social_linkedin',
			'title' 		=> __( 'LinkedIn', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_linkedin']
		),
		'social_slideshare' => array(
			'id' 			=> 'social_slideshare',
			'title' 		=> __( 'Slideshare', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_slideshare']
		),
		'social_foursquare' => array(
			'id' 			=> 'social_foursquare',
			'title' 		=> __( 'Foursquare', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_foursquare']
		),
		'social_flickr' => array(
			'id' 			=> 'social_flickr',
			'title' 		=> __( 'Flickr', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_flickr']
		),
		'social_tumblr' => array(
			'id' 			=> 'social_tumblr',
			'title' 		=> __( 'Tumblr', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_tumblr']
		),
		'social_deviantart' => array(
			'id' 			=> 'social_deviantart',
			'title' 		=> __( 'deviantART', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_deviantart']
		),
		'social_dribbble' => array(
			'id' 			=> 'social_dribbble',
			'title' 		=> __( 'Dribbble', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_dribbble']
		),
		'social_myspace' => array(
			'id' 			=> 'social_myspace',
			'title' 		=> __( 'MySpace', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_myspace']
		),
		'social_wordpress' => array(
			'id' 			=> 'social_wordpress',
			'title' 		=> __( 'WordPress', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_wordpress']
		),
		'social_rss' => array(
			'id' 			=> 'social_rss',
			'title' 		=> __( 'RSS', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_rss']
		),
		'social_delicious' => array(
			'id' 			=> 'social_delicious',
			'title' 		=> __( 'Delicious', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_delicious']
		),
		'social_lastfm' => array(
			'id' 			=> 'social_lastfm',
			'title' 		=> __( 'Last.fm', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_lastfm']
		),
		'social_instagram' => array(
			'id' 			=> 'social_instagram',
			'title' 		=> __( 'Instagram', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_instagram']
		),
		'social_github' => array(
			'id' 			=> 'social_github',
			'title' 		=> __( 'GitHub', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_github']
		),
		'social_vkontakte' => array(
			'id' 			=> 'social_vkontakte',
			'title' 		=> __( 'Vkontakte', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_vkontakte']
		),
		'social_myworld' => array(
			'id' 			=> 'social_myworld',
			'title' 		=> __( 'My World', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_myworld']
		),
		'social_odnoklassniki' => array(
			'id' 			=> 'social_odnoklassniki',
			'title' 		=> __( 'Odnoklassniki', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_odnoklassniki']
		),
		'social_goodreads' => array(
			'id' 			=> 'social_goodreads',
			'title' 		=> __( 'Goodreads', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_goodreads']
		),
		'social_skype' => array(
			'id' 			=> 'social_skype',
			'title' 		=> __( 'Skype', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'sanitize_text_field',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_skype']
		),
		'social_soundcloud' => array(
			'id' 			=> 'social_soundcloud',
			'title' 		=> __( 'Soundcloud', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_soundcloud']
		),
		'social_email' => array(
			'id' 			=> 'social_email',
			'title' 		=> __( 'Email', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'sanitize_email',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_email']
		),
		'social_contact' => array(
			'id' 			=> 'social_contact',
			'title' 		=> __( 'Contact', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_contact']
		),
		'social_xing' => array(
			'id' 			=> 'social_xing',
			'title' 		=> __( 'Xing', 'catch-everest' ),
			'description'	=> '',
			'field_type' 	=> 'url',
			'sanitize' 		=> 'esc_url_raw',
			'panel' 		=> 'social_links',
			'section' 		=> 'predefined_social_icons',
			'default' 		=> $defaults['social_xing']
		),

		//Custom Social Icons
		'custom_social_qty' => array(
			'id' 			=> 'social_custom_qty',
			'title' 		=> __( 'Number of Custom Social Icons', 'catch-everest' ),
			'description'	=> __( 'Save and refresh the page if No. of custom social icon is changed (Max number of icons is 10)', 'catch-everest' ),
			'field_type' 	=> 'number',
			'sanitize' 		=> 'catcheverest_sanitize_number_range',
			'panel' 		=> 'social_links',
			'section' 		=> 'custom_social_links',
			'default' 		=> $defaults['social_custom_qty'],
			'input_attrs' 	=> array(
					            'style' => 'width: 45px;',
					            'min'   => 0,
					            'max'   => 10,
					            'step'  => 1,
					        	)
		),

		//Webmaster Setting
		'google_verification' => array(
			'id' 			=> 'google_verification',
			'title' 		=> __( 'Google Site Verification ID', 'catch-everest' ),
			'description'	=> __( 'Enter your Google ID number only', 'catch-everest' ),
			'field_type' 	=> 'text',
			'sanitize' 		=> 'wp_filter_post_kses',
			'panel' 		=> 'webmaster_tool',
			'section' 		=> 'site_verification',
			'default' 		=> $defaults['google_verification']
		),
		'yahoo_verification' => array(
			'id' 			=> 'yahoo_verification',
			'title' 		=> __( 'Yahoo Site Verification ID', 'catch-everest' ),
			'description'	=> __( 'Enter your Yahoo ID number only', 'catch-everest' ),
			'field_type' 	=> 'text',
			'sanitize' 		=> 'wp_filter_post_kses',
			'panel' 		=> 'webmaster_tool',
			'section' 		=> 'site_verification',
			'default' 		=> $defaults['yahoo_verification']
		),
		'bing_verification' => array(
			'id' 			=> 'bing_verification',
			'title' 		=> __( 'Bing Site Verification ID', 'catch-everest' ),
			'description'	=> __( 'Enter your Bing ID number only', 'catch-everest' ),
			'field_type' 	=> 'text',
			'sanitize' 		=> 'wp_filter_post_kses',
			'panel' 		=> 'webmaster_tool',
			'section' 		=> 'site_verification',
			'default' 		=> $defaults['bing_verification']
		),
		'analytic_header' => array(
			'id' 				=> 'analytic_header',
			'title' 			=> __( 'Code to display on Header', 'catch-everest' ),
			'description' 		=> __( 'Here you can put scripts from Google, Facebook etc. which will load on Header', 'catch-everest' ),
			'field_type' 		=> 'textarea',
			'sanitize' 			=> 'wp_kses_stripslashes',
			'panel' 			=> 'webmaster_tool',
			'section' 			=> 'header_footer_codes',
			'default' 			=> $defaults['analytic_header']
		),
		'analytic_footer' => array(
			'id' 				=> 'analytic_footer',
			'title' 			=> __( 'Code to display on Footer', 'catch-everest' ),
			'description' 		=> __( 'Here you can put scripts from Google, Facebook etc. which will load on Footer', 'catch-everest' ),
			'field_type' 		=> 'textarea',
			'sanitize' 			=> 'wp_kses_stripslashes',
			'panel' 			=> 'webmaster_tool',
			'section' 			=> 'header_footer_codes',
			'default' 			=> $defaults['analytic_footer']
		),
	);

	//@remove Remove if block when WordPress 4.8 is released
	if( !function_exists( 'has_custom_logo' ) ) {
		$settings_custom_header_image = array(
			'featured_header_image' => array(
				'id'              => 'featured_header_image',
				'title'           => __( 'Featured Header Image URL', 'catch-everest' ),
				'description'     => '',
				'field_type'      => 'image',
				'sanitize'        => 'catcheverest_sanitize_image',
				'section'         => 'header_image',
				'default'         => $defaults['featured_header_image'],
				'active_callback' => 'catcheverest_is_header_featured_image_enabled',
				'priority'        => '1'
			),
		);

		$settings_parameters = array_merge( $settings_parameters, $settings_custom_header_image);
	}


	//@remove Remove if block when WordPress 4.8 is released
	if( !function_exists( 'has_site_icon' ) ) {
		$settings_site_icon = array(
			//Favicon
			'remove_favicon' => array(
				'id' 				=> 'remove_favicon',
				'title' 			=> __( 'Check to Disable Favicon', 'catch-everest' ),
				'description'		=> '',
				'field_type' 		=> 'checkbox',
				'sanitize' 			=> 'catcheverest_sanitize_checkbox',
				'panel' 			=> 'theme_options',
				'section' 			=> 'favicon',
				'default' 			=> $defaults['remove_favicon'],
				'active_callback'	=> 'catcheverest_is_site_icon_active'
			),
			'fav_icon' => array(
				'id' 				=> 'fav_icon',
				'title' 			=> __( 'Fav Icon', 'catch-everest' ),
				'description'		=> '',
				'field_type' 		=> 'image',
				'sanitize' 			=> 'catcheverest_sanitize_image',
				'panel' 			=> 'theme_options',
				'section' 			=> 'favicon',
				'default' 			=> $defaults['fav_icon'],
				'active_callback'	=> 'catcheverest_is_site_icon_active'
			),

			//Web Clip Icon
			'remove_web_clip' => array(
				'id' 				=> 'remove_web_clip',
				'title' 			=> __( 'Check to Disable Web Clip Icon', 'catch-everest' ),
				'description'		=> '',
				'field_type' 		=> 'checkbox',
				'sanitize' 			=> 'catcheverest_sanitize_checkbox',
				'panel' 			=> 'theme_options',
				'section' 			=> 'web_clip_icon_options',
				'default' 			=> $defaults['remove_web_clip'],
				'active_callback'	=> 'catcheverest_is_site_icon_active'
			),
			'web_clip' => array(
				'id' 				=> 'web_clip',
				'title' 			=> __( 'Web Clip Icon', 'catch-everest' ),
				'description'		=> '',
				'field_type' 		=> 'image',
				'sanitize' 			=> 'catcheverest_sanitize_image',
				'panel' 			=> 'theme_options',
				'section' 			=> 'web_clip_icon_options',
				'default' 			=> $defaults['web_clip'],
				'active_callback'	=> 'catcheverest_is_site_icon_active'
			),
		);
		$settings_parameters = array_merge( $settings_parameters, $settings_site_icon);
	}

	foreach ( $settings_parameters as $option ) {
		$priority = isset( $option[ 'priority' ] ) ? $option[ 'priority' ] : '';
		$transport = isset( $option[ 'transport' ] ) ? $option[ 'transport' ] : 'refresh';
		if( 'color' == $option['field_type'] ) {
			$wp_customize->add_setting(
				// $id
				$theme_slug . 'options[' . $option['id'] . ']',
				// parameters array
				array(
					'type'				=> 'option',
					'sanitize_callback'	=> $option['sanitize'],
					'default'			=> $option['default'],
					'transport'			=> $transport
				)
			);

			$wp_customize->add_control(
				new WP_Customize_Color_Control(
					$wp_customize,$theme_slug . 'options[' . $option['id'] . ']',
					array(
						'label'			=> $option['title'],
						'section'   	=> $theme_slug . $option['section'],
						'settings'  	=> $theme_slug . 'options[' . $option['id'] . ']',
						'priority'		=> $priority,
						'description' 	=> $option['description'],
						'priority'		=> $priority,
					)
				)
			);
		}
		if( 'image' == $option['field_type'] ) {
			$wp_customize->add_setting(
				// $id
				$theme_slug . 'options[' . $option['id'] . ']',
				// parameters array
				array(
					'type'				=> 'option',
					'sanitize_callback'	=> $option['sanitize'],
					'default'			=> $option['default'],
					'transport'			=> $transport
				)
			);

			$params = array(
						'label'			=> $option['title'],
						'section'   	=> $theme_slug . $option['section'],
						'settings'  	=> $theme_slug . 'options[' . $option['id'] . ']',
						'priority'		=> $priority,
					);

			if ( isset( $option['active_callback']  ) ){
				$params['active_callback'] = $option['active_callback'];
			}

			if ( 'colors' == $option['section'] || 'header_image' == $option['section'] ){
				$params['section'] = $option['section'];
			}

			$wp_customize->add_control(
				new WP_Customize_Image_Control(
					$wp_customize,$theme_slug . 'options[' . $option['id'] . ']',
					$params
				)
			);
		}
		else if ('checkbox' == $option['field_type'] ) {
			$wp_customize->add_setting(
				// $id
				$theme_slug . 'options[' . $option['id'] . ']',
				// parameters array
				array(
					'type'				=> 'option',
					'sanitize_callback'	=> $option['sanitize'],
					'default'			=> $option['default'],
					'transport'			=> $transport,
				)
			);

			$params = array(
						'label'			=> $option['title'],
						'settings'  	=> $theme_slug . 'options[' . $option['id'] . ']',
						'name'  		=> $theme_slug . 'options[' . $option['id'] . ']',
						'priority'		=> $priority,
					);

			if ( isset( $option['active_callback']  ) ){
				$params['active_callback'] = $option['active_callback'];
			}

			if ( 'header_image' == $option['section'] || 'colors' == $option['section'] || 'title_tagline' == $option['section'] ){
				$params['section'] = $option['section'];
			}
			else {
				$params['section']	= $theme_slug . $option['section'];
			}

			$wp_customize->add_control(
				new CatchEverest_Customize_Checkbox(
					$wp_customize,$theme_slug . 'options[' . $option['id'] . ']',
					$params
				)
			);
		}
		else if ('category-multiple' == $option['field_type'] ) {
			$wp_customize->add_setting(
				// $id
				$theme_slug . 'options[' . $option['id'] . ']',
				// parameters array
				array(
					'type'				=> 'option',
					'sanitize_callback'	=> $option['sanitize'],
					'default'			=> $option['default'],
					'transport'			=> $transport
				)
			);

			$params = array(
						'label'			=> $option['title'],
						'section'		=> $theme_slug . $option['section'],
						'settings'		=> $theme_slug . 'options[' . $option['id'] . ']',
						'description'	=> $option['description'],
						'name'	 		=> $theme_slug . 'options[' . $option['id'] . ']',
						'priority'		=> $priority,
					);

			if ( isset( $option['active_callback']  ) ){
				$params['active_callback'] = $option['active_callback'];
			}

			$wp_customize->add_control(
				new CatchEverest_Customize_Dropdown_Categories_Control (
					$wp_customize,
					$theme_slug . 'options[' . $option['id'] . ']',
					$params
				)
			);
		}
		else {
			//Normal Loop
			$wp_customize->add_setting(
				// $id
				$theme_slug . 'options[' . $option['id'] . ']',
				// parameters array
				array(
					'default'			=> $option['default'],
					'type'				=> 'option',
					'sanitize_callback'	=> $option['sanitize'],
					'transport'			=> $transport
				)
			);

			// Add setting control
			$params = array(
					'label'			=> $option['title'],
					'settings'		=> $theme_slug . 'options[' . $option['id'] . ']',
					'type'			=> $option['field_type'],
					'description'   => $option['description'],
					'priority'		=> $priority,
				) ;

			if ( isset( $option['choices']  ) ){
				$params['choices'] = $option['choices'];
			}

			if ( isset( $option['active_callback']  ) ){
				$params['active_callback'] = $option['active_callback'];
			}

			if ( isset( $option['input_attrs']  ) ){
				$params['input_attrs'] = $option['input_attrs'];
			}

			if ( 'header_image' == $option['section'] || 'colors' == $option['section'] ){
				$params['section'] = $option['section'];
			}
			else {
				$params['section']	= $theme_slug . $option['section'];
			}

			$wp_customize->add_control(
				// $id
				$theme_slug . 'options[' . $option['id'] . ']',
				$params
			);
		}
	}

	//Add featured content elements with respect to no of featured content
	for ( $i = 1; $i <= $options[ 'homepage_featured_qty' ]; $i++ ) {
		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[homepage_featured_content_note][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'sanitize_text_field'
			)
		);

		$wp_customize->add_control(
			new CatchEverest_Note_Control(
				$wp_customize, $theme_slug . 'options[homepage_featured_content_note][' . $i . ']',
				array(
					'label'		=> sprintf( __( 'Featured Content #%s', 'catch-everest' ), $i ),
					'section'   => $theme_slug .'homepage_featured_content_options',
					'settings'  => $theme_slug . 'options[homepage_featured_content_note][' . $i . ']',
				)
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[homepage_featured_image][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_image'
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize, $theme_slug . 'options[homepage_featured_image][' . $i . ']',
				array(
					'label'		=> __( 'Image', 'catch-everest' ),
					'section'   => $theme_slug .'homepage_featured_content_options',
					'settings'  => $theme_slug . 'options[homepage_featured_image][' . $i . ']',
				)
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[homepage_featured_url][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'esc_url_raw'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[homepage_featured_url][' . $i . ']',
			array(
				'label'		=> __( 'Link URL', 'catch-everest' ),
				'section'	=> $theme_slug .'homepage_featured_content_options',
				'settings'	=> $theme_slug . 'options[homepage_featured_url][' . $i . ']',
				'type'		=> 'url'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[homepage_featured_base][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_checkbox'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[homepage_featured_base][' . $i . ']',
			array(
				'label'		=> __( 'Check to Open Link in New Window?', 'catch-everest' ),
				'section'	=> $theme_slug .'homepage_featured_content_options',
				'settings'	=> $theme_slug . 'options[homepage_featured_base][' . $i . ']',
				'type'		=> 'checkbox'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[homepage_featured_title][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_checkbox'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[homepage_featured_title][' . $i . ']',
			array(
				'label'			=> __( 'Title', 'catch-everest' ),
				'section'		=> $theme_slug .'homepage_featured_content_options',
				'settings'		=> $theme_slug . 'options[homepage_featured_title][' . $i . ']',
				'description'	=> __( 'Leave empty if you want to remove title', 'catch-everest' ),
				'type'			=> 'text'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[homepage_featured_content][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'wp_kses_post'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[homepage_featured_content][' . $i . ']',
			array(
				'label'			=> __( 'Content', 'catch-everest' ),
				'section'		=> $theme_slug .'homepage_featured_content_options',
				'settings'		=> $theme_slug . 'options[homepage_featured_content][' . $i . ']',
				'description'	=> __( 'Appropriate Words: 10', 'catch-everest' ),
				'type'			=> 'textarea'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_image_slider_author][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_select',
				'default'			=> $defaults['featured_image_slider_author']
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_image_slider_author][' . $i . ']',
			array(
				'label'			=> __( 'Author', 'catch-everest' ),
				'description'	=> '',
				'section'		=> $theme_slug .'homepage_featured_content_options',
				'settings'		=> $theme_slug . 'options[featured_image_slider_author][' . $i . ']',
				'type'			=> 'select',
				'choices'		=> catcheverest_get_users(),
			)
		);
	}

	//Add featured post elements with respect to no of featured sliders
	for ( $i = 1; $i <= $options[ 'slider_qty' ]; $i++ ) {
		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_slider][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_post_id'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_slider][' . $i . ']',
			array(
				'label'				=> sprintf( __( 'Featured Post Slider #%s', 'catch-everest' ), $i ),
				'section'   		=> $theme_slug .'slider_options',
				'settings'  		=> $theme_slug . 'options[featured_slider][' . $i . ']',
				'type'				=> 'text',
					'input_attrs'	=> array(
	        		'style' 		=> 'width: 100px;'
	    		),
				'active_callback'	=> 'catcheverest_is_post_slider_active'
			)
		);
	}

	//Add featured page elements with respect to no of featured slider
	for ( $i = 1; $i <= $options[ 'slider_qty' ]; $i++ ) {
		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_slider_page][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_post_id'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_slider_page][' . $i . ']',
			array(
				'label'		=> sprintf( __( 'Featured Page Slider #%s', 'catch-everest' ), $i ),
				'section'   => $theme_slug .'slider_options',
				'settings'  => $theme_slug . 'options[featured_slider_page][' . $i . ']',
				'type'	   	=> 'dropdown-pages',
				'active_callback' 	=> 'catcheverest_is_page_slider_active'
			)
		);
	}

	//Add featured image elements with respect to no of featured slider
	for ( $i = 1; $i <= $options[ 'slider_qty' ]; $i++ ) {
		$wp_customize->add_setting( $theme_slug . 'options[featured_slider_note]['. $i .']', array(
			'capability'		=> 'edit_theme_options',
			'sanitize_callback'	=> 'sanitize_text_field',
		) );

		$wp_customize->add_control( new Catcheverest_Note_Control(
			$wp_customize,
			$theme_slug . 'options[featured_slider_note]['. $i .']', array(
	        'active_callback'	=> 'catcheverest_is_image_slider_active',
	        'label'		=> __( 'Featured Slide #', 'catch-everest' ) . $i,
	        'section'  	=> $theme_slug .'slider_options',
	        'settings'	=> $theme_slug . 'options[featured_slider_note][' . $i . ']',
	        'type'     	=> 'description',
   		) ) );

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_image_slider_image][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_image'
			)
		);

		$wp_customize->add_control( new WP_Customize_Image_Control(
				$wp_customize,
				$theme_slug . 'options[featured_image_slider_image][' . $i . ']',
				array(
					'label'				=> __( 'Image', 'catch-everest' ),
					'section'   		=> $theme_slug .'slider_options',
					'settings'  		=> $theme_slug . 'options[featured_image_slider_image][' . $i . ']',
					'active_callback' 	=> 'catcheverest_is_image_slider_active'
				)
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_image_slider_link][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'esc_url_raw'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_image_slider_link][' . $i . ']',
			array(
				'label'				=> __( 'Link', 'catch-everest' ),
				'section'   		=> $theme_slug .'slider_options',
				'settings'  		=> $theme_slug . 'options[featured_image_slider_link][' . $i . ']',
				'type'	   			=> 'url',
				'active_callback' 	=> 'catcheverest_is_image_slider_active'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_image_slider_base][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_checkbox'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_image_slider_base][' . $i . ']',
			array(
				'label'				=> __( 'Check to Open Link in New Window/Tab ', 'catch-everest' ),
				'section'   		=> $theme_slug .'slider_options',
				'settings'  		=> $theme_slug . 'options[featured_image_slider_base][' . $i . ']',
				'type'	   			=> 'checkbox',
				'active_callback' 	=> 'catcheverest_is_image_slider_active'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_image_slider_title][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'sanitize_text_field'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_image_slider_title][' . $i . ']',
			array(
				'label'				=> __( 'Title', 'catch-everest' ),
				'section'   		=> $theme_slug .'slider_options',
				'settings'  		=> $theme_slug . 'options[featured_image_slider_title][' . $i . ']',
				'type'	   			=> 'text',
				'active_callback' 	=> 'catcheverest_is_image_slider_active'
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[featured_image_slider_content][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'sanitize_text_field'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[featured_image_slider_content][' . $i . ']',
			array(
				'label'				=> __( 'Content', 'catch-everest' ),
				'section'   		=> $theme_slug .'slider_options',
				'settings'  		=> $theme_slug . 'options[featured_image_slider_content][' . $i . ']',
				'type'	   			=> 'textarea',
				'active_callback' 	=> 'catcheverest_is_image_slider_active'
			)
		);
	}

	//Add custom social elements with respect to number of custom social icons
	for ( $i = 1; $i <= $options[ 'social_custom_qty' ]; $i++ ) {
		$wp_customize->add_setting( $theme_slug . 'options[social_custom_note]['. $i .']', array(
			'capability'		=> 'edit_theme_options',
			'sanitize_callback'	=> 'sanitize_text_field',
		) );

		$wp_customize->add_control( new Catcheverest_Note_Control(
			$wp_customize,
			$theme_slug . 'options[social_custom_note]['. $i .']', array(
	        'label'		=> __( 'Custom Social icon #', 'catch-everest' ) . $i,
	        'section'  	=> $theme_slug .'custom_social_links',
	        'settings'	=> $theme_slug . 'options[social_custom_note][' . $i . ']',
	        'type'     	=> 'description',
   		) ) );

   		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[social_custom_name][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'sanitize_text_field'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[social_custom_name][' . $i . ']',
			array(
				'label'				=> __( 'Name', 'catch-everest' ),
				'section'   		=> $theme_slug .'custom_social_links',
				'settings'  		=> $theme_slug . 'options[social_custom_name][' . $i . ']',
				'type'	   			=> 'text',
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[social_custom_image][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_image'
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				$theme_slug . 'options[social_custom_image][' . $i . ']',
				array(
					'label'		=> sprintf( __( 'Image URL', 'catch-everest' ), $i ),
					'section'   => $theme_slug .'custom_social_links',
					'settings'  => $theme_slug . 'options[social_custom_image][' . $i . ']',
				)
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[social_custom_image_hover][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'catcheverest_sanitize_image'
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				$theme_slug . 'options[social_custom_image_hover][' . $i . ']',
				array(
					'label'		=> sprintf( __( 'Image URL on hover', 'catch-everest' ), $i ),
					'section'   => $theme_slug .'custom_social_links',
					'settings'  => $theme_slug . 'options[social_custom_image_hover][' . $i . ']',
				)
			)
		);

		$wp_customize->add_setting(
			// $id
			$theme_slug . 'options[social_custom_url][' . $i . ']',
			// parameters array
			array(
				'type'				=> 'option',
				'sanitize_callback'	=> 'esc_url_raw'
			)
		);

		$wp_customize->add_control(
			$theme_slug . 'options[social_custom_url][' . $i . ']',
			array(
				'label'				=> __( 'Link', 'catch-everest' ),
				'section'   		=> $theme_slug .'custom_social_links',
				'settings'  		=> $theme_slug . 'options[social_custom_url][' . $i . ']',
				'type'	   			=> 'url',
			)
		);
	}


	// Reset all settings to default
	$wp_customize->add_section( 'catcheverest_reset_all_settings', array(
		'description'	=> __( 'Caution: Reset all settings to default. Refresh the page after save to view full effects.', 'catch-everest' ),
		'priority' 		=> 700,
		'title'    		=> __( 'Reset all settings', 'catch-everest' ),
	) );

	$wp_customize->add_setting( 'catcheverest_options[reset_all_settings]', array(
		'capability'		=> 'edit_theme_options',
		'sanitize_callback' => 'catcheverest_reset_all_settings',
		'transport'			=> 'postMessage',
	) );

	$wp_customize->add_control( 'catcheverest_options[reset_all_settings]', array(
		'label'    => __( 'Check to reset all settings to default', 'catch-everest' ),
		'section'  => 'catcheverest_reset_all_settings',
		'settings' => 'catcheverest_options[reset_all_settings]',
		'type'     => 'checkbox'
	) );
	// Reset all settings to default end

	//Important Links
	$wp_customize->add_section( 'important_links', array(
		'priority' 		=> 999,
		'title'   	 	=> __( 'Important Links', 'catch-everest' ),
	) );

	/**
	 * Has dummy Sanitizaition function as it contains no value to be sanitized
	 */
	$wp_customize->add_setting( 'important_links', array(
		'sanitize_callback'	=> 'catcheverest_sanitize_important_link',
	) );

	$wp_customize->add_control( new CatchEverest_Important_Links( $wp_customize, 'important_links', array(
        'label'   	=> __( 'Important Links', 'catch-everest' ),
        'section'  	=> 'important_links',
        'settings' 	=> 'important_links',
        'type'     	=> 'important_links',
    ) ) );
    //Important Links End
}
add_action( 'customize_register', 'catcheverest_customize_register' );


/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously for catcheverest.
 * And flushes out all transient data on preview
 *
 * @since Catch Everest 1.6.3
 */
function catcheverest_customize_preview() {
	//Remove transients on preview
	catcheverest_themeoption_invalidate_caches();

	global $catcheverest_options_defaults ,$catcheverest_options_settings;

	$catcheverest_options_settings = catcheverest_options_set_defaults( $catcheverest_options_defaults );
}
add_action( 'customize_preview_init', 'catcheverest_customize_preview' );
add_action( 'customize_save', 'catcheverest_customize_preview' );


/**
 * Custom scripts and styles on Customizer for Catch Everest
 *
 * @since Catch Everest 1.4
 */
function catcheverest_customize_scripts() {
	wp_enqueue_script( 'catcheverest_customizer_custom', get_template_directory_uri() . '/inc/panel/js/customizer-custom-scripts.js', array( 'jquery' ), '20140108', true );

}
add_action( 'customize_controls_enqueue_scripts', 'catcheverest_customize_scripts' );


//Active callbacks for customizer
require get_template_directory() . '/inc/panel/customizer/customizer-active-callbacks.php';

//Sanitize functions for customizer
require get_template_directory() . '/inc/panel/customizer/customizer-sanitize-functions.php';
